com.google.cloud.dataflow.sdk.io.bigtable

## Class BigtableIO.Write

- java.lang.Object
- - com.google.cloud.dataflow.sdk.transforms.PTransform<PCollection<KV<com.google.protobuf.ByteString,Iterable<com.google.bigtable.v1.Mutation>>>,PDone>
  - - com.google.cloud.dataflow.sdk.io.bigtable.BigtableIO.Write

All Implemented Interfaces:
  HasDisplayData, Serializable

Enclosing class:
  BigtableIO

    @Experimental
    public static class BigtableIO.Write
    extends PTransform<PCollection<KV<com.google.protobuf.ByteString,Iterable<com.google.bigtable.v1.Mutation>>>,PDone>

A `PTransform` that writes to Google Cloud Bigtable. See the class-level Javadoc on `BigtableIO` for more information.

See Also:
  `BigtableIO`, Serialized Form

### Field Summary

### Fields inherited from class com.google.cloud.dataflow.sdk.transforms.PTransform

`name`

### Method Summary

All Methods Instance Methods Concrete Methods
`PDone` `apply(PCollection<KV<com.google.protobuf.ByteString,Iterable<com.google.bigtable.v1.Mutation>>> input)` Applies this `PTransform` on the given `InputT`, and returns its `Output`.
`com.google.cloud.bigtable.config.BigtableOptions` `getBigtableOptions()` Returns the Google Cloud Bigtable cluster being written to, and other parameters.
`String` `getTableId()` Returns the table being written to.
`void` `populateDisplayData(DisplayData.Builder builder)` Register display data for the given transform or component.
`String` `toString()`
`void` `validate(PCollection<KV<com.google.protobuf.ByteString,Iterable<com.google.bigtable.v1.Mutation>>> input)` Called before invoking apply (which may be intercepted by the runner) to verify this transform is fully specified and applicable to the specified input.
`BigtableIO.Write` `withBigtableOptions(com.google.cloud.bigtable.config.BigtableOptions.Builder optionsBuilder)` Returns a new `BigtableIO.Write` that will write to the Cloud Bigtable cluster indicated by the given options, and using any other specified customizations.
`BigtableIO.Write` `withBigtableOptions(com.google.cloud.bigtable.config.BigtableOptions options)` Returns a new `BigtableIO.Write` that will write to the Cloud Bigtable cluster indicated by the given options, and using any other specified customizations.
`BigtableIO.Write` `withTableId(String tableId)` Returns a new `BigtableIO.Write` that will write to the specified table.

### Methods inherited from class com.google.cloud.dataflow.sdk.transforms.PTransform

`getDefaultOutputCoder, getDefaultOutputCoder, getDefaultOutputCoder, getKindString, getName`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Method Detail

#### withBigtableOptions

    public BigtableIO.Write withBigtableOptions(com.google.cloud.bigtable.config.BigtableOptions options)

Returns a new `BigtableIO.Write` that will write to the Cloud Bigtable cluster indicated by the given options, and using any other specified customizations.

Does not modify this object.

#### withBigtableOptions

    public BigtableIO.Write withBigtableOptions(com.google.cloud.bigtable.config.BigtableOptions.Builder optionsBuilder)

Returns a new `BigtableIO.Write` that will write to the Cloud Bigtable cluster indicated by the given options, and using any other specified customizations.

Clones the given `BigtableOptions` builder so that any further changes will have no effect on the returned `BigtableIO.Write`.

Does not modify this object.

#### withTableId

    public BigtableIO.Write withTableId(String tableId)

Returns a new `BigtableIO.Write` that will write to the specified table.

Does not modify this object.

#### getBigtableOptions

    public com.google.cloud.bigtable.config.BigtableOptions getBigtableOptions()

Returns the Google Cloud Bigtable cluster being written to, and other parameters.

#### getTableId

    public String getTableId()

Returns the table being written to.

#### apply

    public PDone apply(PCollection<KV<com.google.protobuf.ByteString,Iterable<com.google.bigtable.v1.Mutation>>> input)

Description copied from class: `PTransform`
Applies this `PTransform` on the given `InputT`, and returns its `Output`.

Composite transforms, which are defined in terms of other transforms, should return the output of one of the composed transforms. Non-composite transforms, which do not apply any transforms internally, should return a new unbound output and register evaluators (via backend-specific registration methods).

The default implementation throws an exception. A derived class must either implement apply, or else each runner must supply a custom implementation via `PipelineRunner.apply(com.google.cloud.dataflow.sdk.transforms.PTransform<InputT, OutputT>, InputT)`.

Overrides:
  `apply` in class `PTransform<PCollection<KV<com.google.protobuf.ByteString,Iterable<com.google.bigtable.v1.Mutation>>>,PDone>`

#### validate

    public void validate(PCollection<KV<com.google.protobuf.ByteString,Iterable<com.google.bigtable.v1.Mutation>>> input)

Description copied from class: `PTransform`
Called before invoking apply (which may be intercepted by the runner) to verify this transform is fully specified and applicable to the specified input.

By default, does nothing.

Overrides:
  `validate` in class `PTransform<PCollection<KV<com.google.protobuf.ByteString,Iterable<com.google.bigtable.v1.Mutation>>>,PDone>`

#### populateDisplayData

    public void populateDisplayData(DisplayData.Builder builder)

Description copied from class: `PTransform`
Register display data for the given transform or component.

`populateDisplayData(DisplayData.Builder)` is invoked by Pipeline runners to collect display data via `DisplayData.from(HasDisplayData)`. Implementations may call `super.populateDisplayData(builder)` in order to register display data in the current namespace, but should otherwise use `subcomponent.populateDisplayData(builder)` to use the namespace of the subcomponent.

By default, does not register any display data. Implementors may override this method to provide their own display data.

Specified by:
  `populateDisplayData` in interface `HasDisplayData`
Overrides:
  `populateDisplayData` in class `PTransform<PCollection<KV<com.google.protobuf.ByteString,Iterable<com.google.bigtable.v1.Mutation>>>,PDone>`
Parameters:
  `builder` - The builder to populate with display data.
See Also:
  `HasDisplayData`

#### toString

    public String toString()

Overrides:
  `toString` in class `PTransform<PCollection<KV<com.google.protobuf.ByteString,Iterable<com.google.bigtable.v1.Mutation>>>,PDone>`